
/*
 * This is letting the user change the package selection using a dialog
 * based GUI.
 */

#include "gasgui.h"
#include <dialog.h>

#define HELP_TEXT \
"Select and de-select packages.\n"					\
" [*] package installed       [+] package marked for installation\n"	\
" [ ] package not installed   [-] package marked for removal"

char ** items;
struct directory_entry ** entries;
int item_counter;

char *extra_dir_items[] = {
	"a", "Open entire directory tree      ",
	"b", "Close entire directory tree     ",
	"c", "Select all packages in tree     ",
	"d", "Un-Select all packages in tree  "
};

void create_dialog_itemlist(struct directory * dir, int blanks)
{
        struct directory_entry * e;
	char tmpstring[512];
                        
        for (e = dir->list; e != NULL; e = e->next) {
		items[item_counter*2] = malloc(5);
		snprintf(items[item_counter*2], 5, "%4d", item_counter+1);
		entries[item_counter] = e;
		
                if ( e->content_is_subdir ) {
                        snprintf(tmpstring, 512,
			        "%*s(%c) %s/", blanks, "",
				e->content.dir->is_open_in_gui ? '-' : '+',
				e->content.dir->name);
                } else {
                        snprintf(tmpstring, 512,
				"%*s[%c] %s-%s", blanks, "",
                                e->content.pkg->is_installed ?
					( e->content.pkg->will_be_installed ?
							'*' : '-' ) :
					( e->content.pkg->will_be_installed ?
							'+' : ' ' ),
                                e->content.pkg->name,
				e->content.pkg->version);
                }
		items[item_counter*2+1] = malloc(60);
		snprintf(items[item_counter*2+1], 60, "%-*s", 50, tmpstring);
		item_counter++;

		if ( e->content_is_subdir && e->content.dir->is_open_in_gui )
                        create_dialog_itemlist(e->content.dir, blanks+3);
        }
}

void set_tree_flag(struct directory * dir, int set_dir, int value)
{
        struct directory_entry * e;
                        
	if ( set_dir ) dir->is_open_in_gui = value;

        for (e = dir->list; e != NULL; e = e->next) {
                if ( e->content_is_subdir && set_dir)
			e->content.dir->is_open_in_gui = value;

		if ( !e->content_is_subdir && !set_dir)
			e->content.pkg->will_be_installed = value;

		if ( e->content_is_subdir )
                        set_tree_flag(e->content.dir, set_dir, value);
        }
}

void free_dialog_item_list()
{
	for (item_counter--; item_counter>0; item_counter--) {
		free(items[item_counter*2+1]);
		free(items[item_counter*2]);
	}
}

void extra_dir(struct directory * dir)
{
	int rc;

	dialog_vars.extra_button = 0;
	dialog_vars.cancel_label = "Cancel";

	rc = dialog_menu("Directory Extra Functions", "",
			10, 50, 4, 4, extra_dir_items);

	switch(dialog_vars.input_result[0]) {
		case 'a':
			set_tree_flag(dir, 1, 1);
			break;
		case 'b':
			set_tree_flag(dir, 1, 0);
			break;
		case 'c':
			set_tree_flag(dir, 0, 1);
			break;
		case 'd':
			set_tree_flag(dir, 0, 0);
			break;
	}

	dialog_vars.extra_button = 1;
	dialog_vars.cancel_label = "Ok";
}

void extra_pkg(struct package * pkg)
{
}

int do_selection()
{
	int rc;

	/* Create enought space for the items[] and entries[] arrays */
	items = malloc( (directory_entry_count+20) * sizeof(char*) * 2 );
	entries = malloc( (directory_entry_count+20) * sizeof(void*) );

	dialog_vars.default_item = malloc(10);
	dialog_vars.cancel_label = "Ok";
	dialog_vars.ok_label     = "Select";
	dialog_vars.extra_label  = "Extras";
	dialog_vars.extra_button = 1;
	strcpy(dialog_vars.default_item, "1");

	init_dialog();
	while (1) {
		put_backtitle();

		item_counter=0;
		create_dialog_itemlist(rootdir, 0);

		rc = dialog_menu(" G.A.S. (GEM Autoinstall Shell) GUI ",
				HELP_TEXT, 20, 70, 10, item_counter, items);
		if ( rc == 3 ) {
			rc = atoi(dialog_vars.input_result) - 1;
			strcpy(dialog_vars.default_item,
			       dialog_vars.input_result);
			free_dialog_item_list();

			if (entries[rc]->content_is_subdir)
				extra_dir(entries[rc]->content.dir);
			else
				extra_pkg(entries[rc]->content.pkg);

			continue;
		}
		if ( rc ) break;

		rc = atoi(dialog_vars.input_result) - 1;

		if (entries[rc]->content_is_subdir)
			entries[rc]->content.dir->is_open_in_gui =
				! entries[rc]->content.dir->is_open_in_gui;
		else
			entries[rc]->content.pkg->will_be_installed =
				! entries[rc]->content.pkg->will_be_installed;

		strcpy(dialog_vars.default_item, dialog_vars.input_result);
		free_dialog_item_list();
	}
	free_dialog_item_list();
	end_dialog();

	free(items);
	free(entries);

	free(dialog_vars.default_item);
	dialog_vars.default_item = NULL;

	return 0;
}

